package me.wazup.hideandseek;

import java.sql.Statement;
import java.sql.SQLException;
import org.bukkit.Bukkit;
import java.sql.DriverManager;
import java.sql.Connection;

public class MySQL
{
    public String tableName;
    private Connection connection;
    private final String url;
    private final String username;
    private final String password;
    
    public MySQL(final String tableName, final String str, final String str2, final String str3, final String username, final String password) {
        this.connection = null;
        this.url = "jdbc:mysql://" + str + ":" + str2 + "/" + str3;
        this.username = username;
        this.password = password;
        this.tableName = tableName;
        this.connect();
    }
    
    public void connect() {
        try {
            this.connection = DriverManager.getConnection(this.url, this.username, this.password);
            this.setupTable();
        }
        catch (final SQLException ex) {
            Bukkit.getConsoleSender().sendMessage("[HideAndSeek] Failed to connect to mysql, please check if your mysql settings are correct in config.yml");
            ex.printStackTrace();
        }
    }
    
    public Connection getConnection() {
        try {
            if (this.connection == null || !this.connection.isValid(3)) {
                Bukkit.getConsoleSender().sendMessage("[HideAndSeek] Seems like the mysql connection was lost! attempting to reconnect");
                final Long value = System.currentTimeMillis();
                this.connect();
                Bukkit.getConsoleSender().sendMessage("[HideAndSeek] Reconnected successfully, took " + (System.currentTimeMillis() - value) + "ms");
            }
        }
        catch (final SQLException ex) {
            ex.printStackTrace();
        }
        return this.connection;
    }
    
    public void setupTable() {
        try {
            final Statement statement = this.getConnection().createStatement();
            statement.executeUpdate("create table if not exists " + this.tableName + " (player_name VARCHAR(20), player_uuid VARCHAR(60), hiders_killed int, seekers_killed int, wins int, coins int, karma int, games_played int, hider_chance int, play_time VARCHAR(30), exp int, modifier int, special_blocks VARCHAR(300), perks VARCHAR(100), trail int)");
            if (!this.connection.getMetaData().getColumns(null, null, this.tableName, "trail").next()) {
                statement.executeUpdate("ALTER TABLE " + this.tableName + " ADD COLUMN trail int");
            }
            statement.close();
        }
        catch (final SQLException ex) {
            ex.printStackTrace();
        }
    }
}
